//
// AmmoDrop.cpp
//

#include "AmmoDrop.h"

AmmoDrop::AmmoDrop() {
	setType("ammo_drop");
	pos.setX(0);
	pos.setY(0);
	ammo_type = "";
	ammo = 0;
	setSolid(true);
	altitude = 0;
	box.setCorner(pos);
	box.setHorizontal(1);
	box.setVertical(1);
};

AmmoDrop::AmmoDrop(string init_type, int init_ammo, Position init_pos) {
	setType("ammo_drop");
	setPos(init_pos);
	ammo_type = init_type;
	setChar(ammo_type);
	ammo = init_ammo;
	setSolid(true);
	altitude = 0;
	box.setCorner(pos);
	box.setHorizontal(1);
	box.setVertical(1);	
};

AmmoDrop::~AmmoDrop() {

};

void AmmoDrop::setAmmoType(string new_type) {
	ammo_type = new_type;
};

string AmmoDrop::getAmmoType() {
	return ammo_type;
};

void AmmoDrop::setAmmo(int new_ammo) {
	ammo = new_ammo;
};

int AmmoDrop::getAmmo() {
	return ammo;
};

void AmmoDrop::draw() {
	GraphicsManager &graph_man = GraphicsManager::getInstance();
	Position new_pos = graph_man.worldToScreen(pos);
	graph_man.drawCh(new_pos, ch, COLOR_BLUE);
};

int AmmoDrop::eventHandler(Event *e) {
	WorldManager &wm = WorldManager::getInstance();
	if(e->getType() == "EVENT_COLLISION") {
		EventCollision *coll_e = static_cast <EventCollision *> (e);
		if(coll_e->getObj()->getType() == "hero" || coll_e->getObj()->getType() == "FirstEnemy" || coll_e->getObj()->getType() == "SecondEnemy" || coll_e->getObj()->getType() == "SmartEnemy" || coll_e->getObj()->getType() == "BigEnemy" ||coll_e->getObj()->getType() == "SecondBoss") {
			wm.markForDelete(this);
			moveHero(coll_e->getObj(), pos);
		}
	};
}

void AmmoDrop::moveHero(GameObject *p_go, Position new_pos) {
	Position hero_pos = p_go->getPos();
	Position new_hero_pos;
	int x = p_go->getPos().getX();
	int y = p_go->getPos().getY();
	if(p_go->getPos().getX() > new_pos.getX()) {
		x = x -2;
	}
	if(p_go->getPos().getX() + 2 < new_pos.getX()) {
		x = x + 2;
	}
	if(p_go->getPos().getY() > new_pos.getY()) {
		y--;
	}
	if(p_go->getPos().getY() + 2 < new_pos.getY()) {
		y++;
	}
	new_hero_pos.setX(x);
	new_hero_pos.setY(y);
	WorldManager &wm = WorldManager::getInstance();
	wm.moveObj(p_go, new_hero_pos);
};

void AmmoDrop::setChar(string ammo_str) {
	if(ammo_str == "second") {
		ch = 'D';
	}
	else if(ammo_str == "scatter") {
		ch = 'S';
	}
	else if(ammo_str == "rail") {
		ch = 'A';
	}
	else if(ammo_str == "rocket") {
		ch = 'K';
	}
};
