//
//BossHealth.cpp
//

#include "BossHealth.h"
#include "Engine/ResourceManager.h"
#include "Engine/WorldManager.h"
#include "Engine/GameManager.h"
#include "Engine/GraphicsManager.h"
#include <sstream>
#include "EventBoss.h"

using namespace std;

BossHealth::BossHealth(){
	health = 15;
	altitude = 2;
	WorldManager &wm = WorldManager::getInstance();
	Position init_pos(0,wm.getView().getVertical() - 1);
	setPos(init_pos);
	wm.registerInterest(this, "EVENT_BOSS");
	setSolid(false);
};

BossHealth::BossHealth(int init_health){
	health = init_health;
	altitude = 2;
	Position init_pos(0,23);
	setPos(init_pos);
	WorldManager &wm = WorldManager::getInstance();
	wm.registerInterest(this, "EVENT_BOSS");
	setSolid(false);
};

BossHealth::~BossHealth(){
	WorldManager &wm = WorldManager::getInstance();
	wm.unregisterInterest(this, "EVENT_BOSS");
};

int BossHealth::eventHandler(Event *e){
	if(e->getType() == "EVENT_BOSS"){
		EventBoss *e_health = static_cast <EventBoss *> (e);
		health = e_health->getHealth();
		if(health <= 0) {
			WorldManager &wm = WorldManager::getInstance();
			wm.markForDelete(this);
		}
	}
};

void BossHealth::draw() {
	int color = COLOR_YELLOW;
	int tens = health / 10;
	string s_ten;
	stringstream out_ten;
	out_ten << tens;
	s_ten = out_ten.str();
	
	int ones = health % 10;
	string s_one;
	stringstream out_one;
	out_one << ones;
	s_one = out_one.str();
	
	GraphicsManager &graph_man = GraphicsManager::getInstance();
	graph_man.drawCh(pos, 'B',color);
	int new_x = pos.getX() + 1;
	Position new_pos(new_x, pos.getY());
	graph_man.drawCh(new_pos, 'O',color);
	new_x++;
	new_pos.setX(new_x);
	graph_man.drawCh(new_pos, 'S',color);
	new_x++;
	new_pos.setX(new_x);
	graph_man.drawCh(new_pos, 'S',color);
	new_x++;
	new_pos.setX(new_x);
	graph_man.drawCh(new_pos, ':',color);
	new_x++;
	new_pos.setX(new_x);
	graph_man.drawCh(new_pos, s_ten.c_str()[0],color);
	new_x++;
	new_pos.setX(new_x);
	graph_man.drawCh(new_pos, s_one.c_str()[0],color);
};
