//
// DirectionalBullet.cpp
//

#include "DirectionalBullet.h"

DirectionalBullet::DirectionalBullet(int new_direction, Position new_pos) {
	damage = 2;
	direction = new_direction;
	setPos(new_pos);
	distance = 10;
	counter = 3;
	bullet_type = "directional";
};

DirectionalBullet::~DirectionalBullet() {

};

void DirectionalBullet::draw() {
	GraphicsManager &graph_man = GraphicsManager::getInstance();
	char temp;
	if(direction == UP || direction == DOWN) {
		temp = '|';
	}
	else if(direction == RIGHT || direction == LEFT) {
		temp = '-';
	}
	else if(direction == UP_LEFT || direction == DOWN_RIGHT) {
		temp = '\\';
	}
	else {
		temp = '/';
	}
	Position new_pos = graph_man.worldToScreen(pos);
	graph_man.drawCh(new_pos, temp);
};

void DirectionalBullet::move() {
	int x = pos.getX();
	int y = pos.getY();
	if(direction == UP || direction == UP_LEFT || direction == UP_RIGHT) {
		y--;
	}
	if(direction == DOWN || direction == DOWN_RIGHT || direction == DOWN_LEFT) {
		y++;
	}
	if(direction == LEFT || direction == UP_LEFT || direction == DOWN_LEFT) {
		x = x-2;
	}
	if(direction == RIGHT || direction == UP_RIGHT || direction == DOWN_RIGHT) {
		x = x+2;
	}
	WorldManager &wm = WorldManager::getInstance();
	Position new_pos(x,y);
	distance--;
	if(x < 0 || y < 0 || x > wm.getBoundary().getHorizontal() || y > wm.getBoundary().getVertical() || distance == 0) {
		wm.markForDelete(this);
		return;		
	}
	wm.moveObj(this, new_pos);
	if(pos.getX() == new_pos.getX() && pos.getY() == pos.getY()) {
		box.setCorner(new_pos);
	}
};
