///
/// EnemyFactory.h
///

#ifndef __ENEMY_FACTORY_H__
#define __ENEMY_FACTORY_H__

#include "FirstEnemy.h"
#include "SecondEnemy.h"
#include "MovingObstacle.h"
#include "StaticObstacle.h"
#include "SmartEnemy.h"
#include "Hero.h"
#include "Timer.h"
#include "Lives.h"
#include "Ammo.h"
#include "GunLabel.h"
#include "Title.h"
#include "Instructions.h"
#include "Engine/WorldManager.h"
#include "Engine/GameObject.h"
#include "Engine/GameObjectList.h"
#include "Engine/Box.h"
#include "Engine/Event.h"

#define MAX_ENEM1
#define MAX_ENEM2
#define MAX_MA
#define MAX_SO

class EnemyFactory : public GameObject {

 private:
  EnemyFactory (EnemyFactory const&);
  void operator=(EnemyFactory const&);
  EnemyFactory();

 protected:
  int start_up;
  int level;
  int curr_enem1;
  int curr_enem2;
  int curr_MO;
  int curr_SO;
  int curr_enemS;
  int max_MO;
  int max_SO;
  int max_enem1;
  int max_enem2;
  int max_enemS;
  int life;
  int spawn_delay;
  Hero hero;
  GameObject *boss;
  GameObjectList enemies;
  bool bossFight;

 public:
  ~EnemyFactory();
  static EnemyFactory &getInstance();
  void startLevel();
  void bossSpawn();
  void addEnemy(GameObject *enemy);
  void removeEnemy(GameObject *enemy);
  int eventHandler(Event *e);
  bool checkPosition(Box enem_box);
  bool offScreen(Box enem_box);
  void draw();
  int getLevel();
  void setLevel(int new_level);
  Hero &getHero();
  void wipeScreen();
  GameObject* getBoss();
  bool isBoss();
  void spawnAmmo(Position new_pos);
};

#endif
