//
//Clock.cpp
//

#include "Clock.h"
#include <unistd.h>
#include <iostream>
#include <time.h>

//initialization
Clock::Clock() {
  clock_gettime(CLOCK_REALTIME, &prev_ts);
};

long int Clock::delta() {

  #ifdef __linux__ || __CYGWIN__
  //for Linux/Cygwin (and copied from class slides)
  struct timespec curr_ts;
  long int curr_microsec, prev_microsec;

  long int elapsed_time; // in microseconds

  clock_gettime(CLOCK_REALTIME, &curr_ts); // stop timer

  // convert to total microseconds
  curr_microsec = curr_ts.tv_sec*1000000 + curr_ts.tv_nsec/1000;
  prev_microsec = prev_ts.tv_sec*1000000 + prev_ts.tv_nsec/1000;
  prev_ts = curr_ts;
  elapsed_time = curr_microsec - prev_microsec;

  return elapsed_time;

  #endif
};
