///
/// gameManager.h
///

#ifndef __GAME_MANAGER_H__
#define __GAME_MANAGER_H__

#include <time.h>

#include "Manager.h"
#include "Clock.h"
#include "WorldManager.h"
#include "EventStep.h"

#define DEFAULT_FRAME_TIME 33

class GameManager : public Manager {

 private:
  GameManager (GameManager const&);
  void operator=(GameManager const&);
  GameManager();

 protected:
  bool game_over;

 public:
  ~GameManager();
  static GameManager &getInstance();
  int startUp();
  int startUp(bool append, bool flush);
  int startUp(bool append, bool flush, time_t seed);
  void shutDown();
  void run();
  void run(int frame_time);
  void setGameOver();
};

#endif
