//
//GameObject.cpp
//

#include "GameObject.h"
#include "WorldManager.h"
#include "LogManager.h"
#include "GraphicsManager.h"
#include <stdio.h>

GameObject::GameObject() {
  ch = ' ';
  is_solid = false;
  altitude = 0;
  sprite_index = 0;
  sprite_center = false;
  sprite_slowdown = 0;
  sprite_slowdown_count = 0;
  WorldManager &wm = WorldManager::getInstance();
  wm.insertObj(this);
};

GameObject::~GameObject() {
  WorldManager &wm = WorldManager::getInstance();
};

void GameObject::setId(int new_id) {
  id = new_id;
};

int GameObject::getId() {
  return id;
};

void GameObject::setType(string new_type) {
  type = new_type;
};

string GameObject::getType() {
  return type;
};

void GameObject::setSolid(bool solid) {
  is_solid = solid;
};

bool GameObject::isSolid() {
  return is_solid;
};

void GameObject::setPos(Position new_pos) {
  pos = new_pos;
};

Position GameObject::getPos() {
  return pos;
};

void GameObject::setAltitude(int new_altitude) {
  altitude = new_altitude;
};

int GameObject::getAltitude() {
  return altitude;
};

int GameObject::eventHandler(Event *p_event) {

};

void GameObject::setCh(char new_ch){
  ch = new_ch;
};

char GameObject::getCh(){
  return ch;
};

void GameObject::draw(){
	GraphicsManager &gm = GraphicsManager::getInstance();
	LogManager &lm = LogManager::getInstance();
	//lm.writeLog("drawing object...");
	if(sprite_slowdown == 0) {
		//lm.writeLog("drawing character, not sprite");
		gm.drawCh(pos,ch);
	}
	else {
		//lm.writeLog("Adding to the count, which is now %d compared to %d", sprite_slowdown_count, sprite_slowdown);
		int count = sprite_slowdown_count + 1;
		if(count >= sprite_slowdown){
			sprite_slowdown_count = 0;
			if(p_sprite) {
				int next = sprite_index + 1;
				//lm.writeLog("frame count - %d", sprite_index);
				if(next == p_sprite->getFrameCount()) {
					next = 0;
				}
				sprite_index = next;
				//lm.writeLog("drawing frame %d of sprite", sprite_index);
				Frame frame = p_sprite->getFrame(sprite_index);
				gm.drawFrame(pos, frame, sprite_center, p_sprite->getColor());
				
			}
			else {
				//lm.writeLog("no sprite");
			};
		}
		else {
			sprite_slowdown_count = count;
			Frame frame = p_sprite->getFrame(sprite_index);
			gm.drawFrame(pos, frame, sprite_center, p_sprite->getColor());
		};
	};
};

void GameObject::setSprite(Sprite *p_new_sprite) {
	p_sprite = p_new_sprite;
};

bool GameObject::isCentered() {
	return sprite_center;
};

void GameObject::setCentered(bool centered) {
	sprite_center = centered;
};

int GameObject::getSpriteIndex() {
	return sprite_index;
};

void GameObject::setSpriteIndex(int new_index) {
	sprite_index = new_index;
};

int GameObject::getSpriteSlowdown() {
	return sprite_slowdown;
};

void GameObject::setSpriteSlowdown(int new_slowdown) {
	sprite_slowdown = new_slowdown;
};

int GameObject::getSpriteSlowdownCount() {
	return sprite_slowdown_count;
};

void GameObject::setSpriteSlowdownCount(int new_count) {
	sprite_slowdown_count = new_count;
};

Box GameObject::getBox() {
	return box;
};

void GameObject::setBox(Box new_box) {
	box = new_box;
};
