///
/// gameObject.h
///

#ifndef __GAME_OBJECT_H__
#define __GAME_OBJECT_H__

#include "Position.h"
#include "Event.h"
#include "Sprite.h"
#include "Box.h"
#include <string>

class GameObject {

 private:
  int id;

 protected:
  string type;
  Position pos;
  bool is_solid;
  int altitude;
  char ch;
  bool sprite_center;
  int sprite_index;
  int sprite_slowdown;
  int sprite_slowdown_count;
  Sprite *p_sprite;
  Box box;
  
 public:
  GameObject();
  virtual ~GameObject();
  void setId(int new_id);
  int getId();
  void setType(string new_type);
  string getType();
  void setSolid(bool solid);
  bool isSolid();
  void setPos(Position new_pos);
  Position getPos();
  void setAltitude(int new_altitude);
  int getAltitude();
  virtual int eventHandler(Event *p_event);
  void setCh(char new_ch);
  char getCh();
  virtual void draw();
  void setSprite(Sprite *p_new_sprite);
  bool isCentered();
  void setCentered(bool centered);
  int getSpriteIndex();
  void setSpriteIndex(int new_index);
  void setSpriteSlowdown(int new_slowdown);
  int getSpriteSlowdown();
  int getSpriteSlowdownCount();
  void setSpriteSlowdownCount(int new_count);
  void setBox(Box new_box);
  Box getBox();
};
 
#endif
