///
/// graphicsManager.h
//

#ifndef __GRAPHICS_MANAGER_H__
#define __GRAPHICS_MANAGER_H__

#ifdef CYGWIN
#include <ncurses/curses.h>
#else
#include <curses.h>
#endif

#define COLOR_DEFAULT COLOR_WHITE

#include "Manager.h"
#include "Position.h"
#include <curses.h>

class GraphicsManager : public Manager {

 private:
  GraphicsManager (GraphicsManager const&);
  void operator=(GraphicsManager const&);
  GraphicsManager();

 protected:
  WINDOW *win1;
  int current;
  int window_horiz;
  int window_vert;

 public:
  ~GraphicsManager();
  static GraphicsManager &getInstance();
  int startUp();
  void shutDown();
  int swapBuffers();
  int drawCh(Position world_pos, char ch);
  int drawCh(Position world_pos, char ch, int color);
  int getHorizontal();
  int getVertical();
  Position worldToScreen(Position world_pos);
  int drawFrame(Position world_pos, Frame frame, bool centered, int color);
};

#endif
