//
//InputManager.cpp
//

#include "InputManager.h"
#include "LogManager.h"
#include "GraphicsManager.h"
#include "GameManager.h"
#include "WorldManager.h"
#include "EventMouse.h"
#include "EventKeyboard.h"
#include <cstdlib>
#include <stdio.h>

InputManager::InputManager() {
  is_started = false;
};

InputManager::InputManager(InputManager const&) {

};

void InputManager::operator=(InputManager const&) {

};

InputManager::~InputManager() {

};

InputManager &InputManager::getInstance() {
  static InputManager instance;
  return instance;
};

bool InputManager::isValid(string event_name){

};

int InputManager::startUp(){
  GraphicsManager &grm = GraphicsManager::getInstance();
  GameManager &gm = GameManager::getInstance();
  LogManager &lm = LogManager::getInstance();
  if(grm.getHorizontal() ==0){
    lm.writeLog("ERROR:Tried to start input manager without starting graphics manager");
    gm.shutDown();
  }
  cbreak();
  nodelay(stdscr,true);
  nonl();
  noecho();
  curs_set(0);
  mmask_t mask = BUTTON1_CLICKED | BUTTON2_CLICKED |
    BUTTON1_DOUBLE_CLICKED | BUTTON2_DOUBLE_CLICKED;
  mousemask(mask,NULL);
  keypad(stdscr,true);
  is_started = true;
  lm.writeLog("Input Manager started");
};

void InputManager::shutDown(){
  LogManager &lm = LogManager::getInstance();  
  curs_set(-1);
  is_started = false;
  lm.writeLog("Input Manager shut down");
};

void InputManager::getInput(){
  WorldManager &wm = WorldManager::getInstance();
  LogManager &lm = LogManager::getInstance();
 // lm.writeLog("Checking input");
  int c = getch();
  if(c!=ERR){
    MEVENT m_event;
    if(c==KEY_MOUSE && getmouse(&m_event)==OK){
      EventMouse *mouse = new EventMouse();
      if(m_event.bstate & BUTTON1_CLICKED){
        lm.writeLog("Left button clicked at %i, %i",m_event.x,m_event.y);
        mouse->setMouseX(m_event.x);
        mouse->setMouseY(m_event.y);
        mouse->setMouseAction(LEFT_BUTTON_CLICK);
        wm.onEvent(mouse);
      }
      if(m_event.bstate & BUTTON2_CLICKED){
        mouse->setMouseX(m_event.x);
        mouse->setMouseY(m_event.y);
        mouse->setMouseAction(RIGHT_BUTTON_CLICK);
        wm.onEvent(mouse);
      }
      if(m_event.bstate & BUTTON1_DOUBLE_CLICKED){
        mouse->setMouseX(m_event.x);
        mouse->setMouseY(m_event.y);
        mouse->setMouseAction(LEFT_BUTTON_DOUBLECLICK);
        wm.onEvent(mouse);
      }
      if(m_event.bstate & BUTTON2_DOUBLE_CLICKED){
        mouse->setMouseX(m_event.x);
        mouse->setMouseY(m_event.y);
        mouse->setMouseAction(RIGHT_BUTTON_DOUBLECLICK);
        wm.onEvent(mouse);
      }
    }
    //keyboard
    else{
      //lm.writeLog("%i was pressed",c);
      EventKeyboard *keyboard = new EventKeyboard();
      keyboard->setKey(c);
      onEvent(keyboard);
    }
  }
};

bool InputManager::isStarted(){
  return is_started;
};
