//
//Manager.cpp
//

#include "Manager.h"
#include "GameObject.h"
#include "GameObjectList.h"
#include "GameObjectListIterator.h"
#include <stdio.h>
#include "LogManager.h"

Manager::Manager() {
  event_list_count = 0;
  bool is_started = false;
};

Manager::~Manager() {

};

bool Manager::isValid(string event_name) {
  for(int i=1; i<event_list_count;i++){
    if(event[i] == event_name)
      return true;
  }
  return false;
};

void Manager::onEvent(Event *p_event) {
  int index = 0;
  for(int i=0; i<event_list_count;i++){
    if(event[i] == p_event->getType()){
      index = i;
      break;
    }
  }
  GameObjectList objs_with_event = obj_list[index];
  GameObjectListIterator iter = objs_with_event.createIterator();
  while(!iter.isDone()){
      iter.currentObj()->eventHandler(p_event);
      iter.next();
  }
};

int Manager::registerInterest(GameObject *p_go, string event_name) {
  LogManager &lm = LogManager::getInstance();
  int index = 0;
  bool new_event = true;
  for(int i=0; i<event_list_count;i++){
    if(event[i] == event_name){
      index = i;
      new_event = false;
    }
  }
  if(new_event){
    event[event_list_count] = event_name;
    index = event_list_count;
    event_list_count++;
  }
  
  GameObjectList objs_with_event = obj_list[index];
  GameObjectListIterator iter = objs_with_event.createIterator();
  while(!iter.isDone()){
      if(iter.currentObj()==p_go)
        return -1;
      iter.next();
  }
  obj_list[index].insert(p_go);
  return 0;

};

int Manager::unregisterInterest(GameObject *p_go, string event_name) {
  int index = 0;
  bool new_event = true;
  for(int i=0; i<event_list_count;i++){
    if(event[i] == event_name){
      index = i;
      new_event = false;
    }
  }
  if(new_event){
    return -1;
  }
  
  GameObjectList objs_with_event = obj_list[index];
  GameObjectListIterator iter = objs_with_event.createIterator();
  while(!iter.isDone()){
      if(iter.currentObj()==p_go) {
		obj_list[index].remove(p_go);
		if(obj_list[index].getCount() == 0) {
			for(int i = index; i < event_list_count;i++) {
				event[i] = event[i + 1];
			}
			event_list_count--;
		};
        return 0;
	  };
      iter.next();
  }
  
  return -1;
};

int Manager::startUp() {
  is_started = true;
};

void Manager::shutDown() {
  is_started = false;
};

bool Manager::isStarted() {
  return is_started;
};
