/*
* ResourceManager.h
*/

#ifndef __RESOURCE_MANAGER_H__
#define __RESOURCE_MANAGER_H__

#define MAX_SPRITES 10000

#include <string>

using namespace std;

#include "Manager.h"
#include "Sprite.h"

#define FRAMES_TOKEN "frames"
#define HEIGHT_TOKEN "height"
#define WIDTH_TOKEN "width"
#define COLOR_TOKEN "color"
#define END_FRAME_TOKEN "end"
#define END_SPRITE_TOKEN "eof"

class ResourceManager : public Manager {
	private:
		ResourceManager (ResourceManager const&);
		void operator=(ResourceManager const&);
		ResourceManager();
	
	protected:
		Sprite *sprite[MAX_SPRITES];
		int sprite_count;
		
	public:
		~ResourceManager();
		
		static ResourceManager &getInstance() {
			static ResourceManager instance;
			return instance;
		}
		
		int loadSprite(string filename, string label);
		
		int loadSprite(string sprite, int height, int width, int frames, int color, string label);
		
		Sprite *getSprite(string label);
		
		int startUp();
		void shutDown();
};

#endif
