//
// GunLabel.cpp
//

#include "GunLabel.h"

GunLabel::GunLabel() {
	gun = "1.STANDARD";
	WorldManager &wm = WorldManager::getInstance();
	Position new_pos(33,wm.getView().getVertical() - 1);
	setPos(new_pos);
	altitude = 2;
	setSolid(false);
	wm.registerInterest(this, "EVENT_GUN_CHANGE");
};

GunLabel::~GunLabel() {
	WorldManager &wm = WorldManager::getInstance();
	wm.unregisterInterest(this, "EVENT_GUN_CHANGE");
};

string GunLabel::getGun() {
	return gun;
};

void GunLabel::draw() {
	int length = strlen(gun.c_str());
	GraphicsManager &graph_man = GraphicsManager::getInstance();
	for(int i = 0; i < length; i++) {
		int new_x = pos.getX() + i;
		Position  new_pos(new_x, pos.getY());
		graph_man.drawCh(new_pos, gun[i],COLOR_YELLOW);
	}
};

int GunLabel::eventHandler(Event *e) {
	if(e->getType() == "EVENT_GUN_CHANGE") {
		EventGunChange *e_gun = static_cast <EventGunChange *> (e);
		changeGun(e_gun);
	}
};

void GunLabel::changeGun(EventGunChange *e) {
	string temp = e->getGunType();
	if(temp == "standard") {
		gun = "1.STANDARD";
	}
	else if(temp == "second") {
		gun = "2.DIRECTIONAL";
	}
	else if(temp == "scatter") {
		gun = "3.SCATTER";
	}
	else if(temp == "rail") {
		gun = "4.RAIL GUN";
	}
	else if(temp == "rocket") {
		gun = "5.ROCKETS";
	}
};
