//
//Hero.h
//

#ifndef __HERO_H__
#define __HERO_H__

#include "Engine/GameObject.h"
#include "Engine/Event.h"
#include "Engine/EventStep.h"
#include "Engine/EventKeyboard.h"
#include "Engine/EventCollision.h"
#include "Engine/WorldManager.h"
#include "Engine/InputManager.h"
#include "Engine/ResourceManager.h"
#include "Engine/LogManager.h"
#include "Engine/GraphicsManager.h"
#include "Engine/GameManager.h"
#include "Bullet.h"

#define LEFT 1
#define UP 2
#define RIGHT 3
#define DOWN 4
#define UP_LEFT 5
#define DOWN_LEFT 6
#define UP_RIGHT 7
#define DOWN_RIGHT 8

#define STANDARD 0
#define SECOND 1
#define SCATTER 2
#define RAIL 3
#define ROCKET 4
#define HEATSEEKER 5
#define MAX_GUNS 6

class Hero: public GameObject{

protected:
	void move(int direction);
	void out();
	void keyProcess(EventKeyboard *e);
	void shoot(int new_direction);
	void addAmmo(EventCollision *e);
	int shot_counter;
	int move_counter;
	int lives;
	string gun_type[MAX_GUNS];
	int ammo_count[MAX_GUNS];
	int current_gun;
	void shootDirectional();
	void shootScatter(int dir);
	void shootRailGun(int dir);

public:
	Hero();
	~Hero();
	int eventHandler(Event *e);
};

#endif
