//
// Instructions.cpp
//

#include "Instructions.h"
#include "Engine/ResourceManager.h"
#include "Engine/WorldManager.h"

Instructions::Instructions() {
	altitude = -2;
	count = 30;
	time = 10;
	pos.setX(45);
	pos.setY(30);
	setSolid(false);
	ResourceManager &rm = ResourceManager::getInstance();
	p_sprite = rm.getSprite("instructions");
	sprite_index = 0;
	sprite_slowdown = 60;
	sprite_slowdown_count = 0;
	WorldManager &wm = WorldManager::getInstance();
	wm.registerInterest(this, "EVENT_STEP");
}

Instructions::~Instructions() {
	WorldManager &wm = WorldManager::getInstance();
	wm.unregisterInterest(this, "EVENT_STEP");
};

int Instructions::eventHandler(Event *e) {
	if(e->getType() == "EVENT_STEP") {
		count--;
		if(count == 0) {
			time--;
			count = 30;
			if(time == 0) {
				WorldManager &wm = WorldManager::getInstance();
				wm.markForDelete(this);
			}
		}
	}
};
