//
// Instructions3.cpp
//

#include "Instructions3.h"
#include "Engine/ResourceManager.h"
#include "Engine/WorldManager.h"

Instructions3::Instructions3() {
	WorldManager &wm = WorldManager::getInstance();
	altitude = -2;
	count = 30;
	time = 10;
	pos.setX(wm.getView().getCorner().getX() + 17);
	pos.setY(wm.getView().getCorner().getY() + 18);
	setSolid(false);
	ResourceManager &rm = ResourceManager::getInstance();
	p_sprite = rm.getSprite("instructions3");
	sprite_index = 0;
	sprite_slowdown = 60;
	sprite_slowdown_count = 0;
	wm.registerInterest(this, "EVENT_STEP");
}

Instructions3::~Instructions3() {
	WorldManager &wm = WorldManager::getInstance();
	wm.unregisterInterest(this, "EVENT_STEP");
};

int Instructions3::eventHandler(Event *e) {
	if(e->getType() == "EVENT_STEP") {
		count--;
		if(count == 0) {
			time--;
			count = 30;
			if(time == 0) {
				WorldManager &wm = WorldManager::getInstance();
				wm.markForDelete(this);
			}
		}
	}
};
