//
// LifeDrop.cpp
//

#include "LifeDrop.h"
#include "Hero.h"
#include "Engine/EventCollision.h"

LifeDrop::LifeDrop() {
	setType("life_drop");
	pos.setX(0);
	pos.setY(0);
	setSolid(true);
	altitude = 0;
	box.setHorizontal(1);
	box.setVertical(1);
};

LifeDrop::LifeDrop(Position new_pos) {
	setType("life_drop");
	setPos(new_pos);
	setSolid(true);
	altitude = 0;
	box.setCorner(pos);
	box.setHorizontal(1);
	box.setVertical(1);
};

LifeDrop::~LifeDrop() {

};

void LifeDrop::draw() {
	GraphicsManager &graph_man = GraphicsManager::getInstance();
	Position new_pos = graph_man.worldToScreen(pos);
	graph_man.drawCh(new_pos, '+');
};

int LifeDrop::eventHandler(Event *e) {
	WorldManager &wm = WorldManager::getInstance();
	if(e->getType() == "EVENT_COLLISION") {
		EventCollision *coll_e = static_cast <EventCollision *> (e);
		if(coll_e->getObj()->getType() == "hero" || coll_e->getObj()->getType() == "FirstEnemy" || coll_e->getObj()->getType() == "SecondEnemy" || coll_e->getObj()->getType() == "SmartEnemy" || coll_e->getObj()->getType() == "BigEnemy" ||coll_e->getObj()->getType() == "SecondBoss") {
			wm.markForDelete(this);
			moveHero(coll_e->getObj(), pos);
		}
	}
};

void LifeDrop::moveHero(GameObject *p_go, Position new_pos) {
	Position hero_pos = p_go->getPos();
	Position new_hero_pos;
	int x = p_go->getPos().getX();
	int y = p_go->getPos().getY();
	if(p_go->getPos().getX() > new_pos.getX()) {
		x = x -2;
	}
	if(p_go->getPos().getX() + 2 < new_pos.getX()) {
		x = x + 2;
	}
	if(p_go->getPos().getY() > new_pos.getY()) {
		y--;
	}
	if(p_go->getPos().getY() + 2 < new_pos.getY()) {
		y++;
	}
	new_hero_pos.setX(x);
	new_hero_pos.setY(y);
	WorldManager &wm = WorldManager::getInstance();
	wm.moveObj(p_go, new_hero_pos);
};
