//
// Lives.cpp
//

#include "Lives.h"
#include "Engine/GraphicsManager.h"
#include <sstream>
#include "Engine/WorldManager.h"
#include "EventLife.h"

Lives::Lives() {
	lives = 3;
	setSolid(false);
	altitude = 2;
	WorldManager &wm = WorldManager::getInstance();
	Position init_pos(11, wm.getView().getVertical() - 1);
	setPos(init_pos);
	wm.registerInterest(this, "EVENT_LIFE");
};

Lives::Lives(int init_lives) {
	lives = init_lives;
	Position init_pos(8, 23);
	setPos(init_pos);
	WorldManager &wm = WorldManager::getInstance();
	wm.registerInterest(this, "EVENT_LIFE");
};

Lives::~Lives() {
	WorldManager &wm = WorldManager::getInstance();
	wm.unregisterInterest(this, "EVENT_LIFE");
};

int Lives::eventHandler(Event *e) {
	if(e->getType() == "EVENT_LIFE") {
		EventLife *e_life = static_cast <EventLife *> (e);
		lives = e_life->getLives();
	}
};

void Lives::draw() {
	int color = COLOR_YELLOW;
	string lives_string;
	stringstream out_lives;
	out_lives << lives;
	lives_string = out_lives.str();

	GraphicsManager &graph_man = GraphicsManager::getInstance();
	graph_man.drawCh(pos, 'L',color);
	int new_x = pos.getX() + 1;
	Position new_pos(new_x, pos.getY());
	graph_man.drawCh(new_pos, 'I',color);
	new_x++;
	new_pos.setX(new_x);
	graph_man.drawCh(new_pos, 'V',color);
	new_x++;
	new_pos.setX(new_x);
	graph_man.drawCh(new_pos, 'E',color);
	new_x++;
	new_pos.setX(new_x);
	graph_man.drawCh(new_pos, 'S',color);
	new_x++;
	new_pos.setX(new_x);
	graph_man.drawCh(new_pos, ':',color);
	new_x++;
	new_pos.setX(new_x);
	graph_man.drawCh(new_pos, lives_string.c_str()[0],color);
	
};

int Lives::getLives() {
	return lives;
};

void Lives::setLives(int new_lives) {
	lives = new_lives;
};
