//
// Rocket.cpp
//

#include "Rocket.h"
#include "RocketExplosion.h"

Rocket::Rocket(Position init_pos, int dir) {
	bullet_type = "rocket";
	init_counter = 4;
	counter = init_counter;
	setPos(init_pos);
	direction = dir;
	distance = 12;
};

Rocket::~Rocket() {

};

void Rocket::draw() {
	GraphicsManager &graph_man = GraphicsManager::getInstance();
	Position screen_pos = graph_man.worldToScreen(pos);
	graph_man.drawCh(screen_pos, 'D');
};

int Rocket::eventHandler(Event *e) {
	WorldManager &wm = WorldManager::getInstance();
	if(e->getType() == "EVENT_STEP") {
		counter--;
		if(counter == 0) {
			counter = init_counter;
			move();
		}
	}
	if(e->getType() == "EVENT_COLLISION") {
		EventCollision *coll_e = static_cast <EventCollision *> (e);
		if(coll_e->getObj()->getType() != "hero") {
			wm.markForDelete(this);
			new RocketExplosion(pos);
		}
	}
	if(e->getType() == "EVENT_OFFSCREEN") {
		wm.markForDelete(this);
	}
};

void Rocket::move() {
	int x = pos.getX();
	int y = pos.getY();
	if(direction == UP) {
		y--;
	}
	else if(direction == DOWN) {
		y++;
	}
	else if(direction == LEFT) {
		x = x-2;
	}
	else if(direction == RIGHT) {
		x = x+2;
	}
	WorldManager &wm = WorldManager::getInstance();
	Position new_pos(x,y);
	if(distance > 0) {
		distance--;
	};
	if(distance == 0) {
		wm.markForDelete(this);
		new RocketExplosion(pos);
	}
	if(x < 0 || y < 0 || x > wm.getBoundary().getHorizontal() || y > wm.getBoundary().getVertical()) {
		wm.markForDelete(this);
		return;		
	}
	wm.moveObj(this, new_pos);
	if(pos.getX() == new_pos.getX() && pos.getY() == pos.getY()) {
		box.setCorner(new_pos);
	}
};
