//
//Timer.cpp
//

#include "Timer.h"
#include "Engine/ResourceManager.h"
#include "Engine/WorldManager.h"
#include "Engine/GameManager.h"
#include "Engine/GraphicsManager.h"
#include <sstream>
#include "EnemyFactory.h"

using namespace std;

Timer::Timer(){
	altitude = 2;
	time_sec = 99;
	counter = 60;
	Position init_pos(0,23);
	setPos(init_pos);
	WorldManager &wm = WorldManager::getInstance();
	wm.registerInterest(this, "EVENT_STEP");
	setSolid(false);
	start_up = 300;
};

Timer::~Timer(){
	WorldManager &wm = WorldManager::getInstance();
	wm.unregisterInterest(this, "EVENT_STEP");
};

int Timer::eventHandler(Event *e){
	if(e->getType() == "EVENT_STEP"){
		if(start_up == 0) {
			counter--;
			if(counter <= 0) {
				counter = 60;
				time_sec--;
				if(time_sec <= 0) {
					WorldManager &wm = WorldManager::getInstance();
					EnemyFactory &ef = EnemyFactory::getInstance();
					ef.bossSpawn();
					wm.markForDelete(this);
				}
			}
		}
		else {
			start_up--;
		}
	}
};

void Timer::draw() {
	int tens = time_sec / 10;
	string s_ten;
	stringstream out_ten;
	out_ten << tens;
	s_ten = out_ten.str();
	
	int ones = time_sec % 10;
	string s_one;
	stringstream out_one;
	out_one << ones;
	s_one = out_one.str();
	
	GraphicsManager &graph_man = GraphicsManager::getInstance();
	graph_man.drawCh(pos, 'T', COLOR_YELLOW);
	int new_x = pos.getX() + 1;
	Position new_pos(new_x, pos.getY());
	graph_man.drawCh(new_pos, 'I', COLOR_YELLOW);
	new_x++;
	new_pos.setX(new_x);
	graph_man.drawCh(new_pos, 'M', COLOR_YELLOW);
	new_x++;
	new_pos.setX(new_x);
	graph_man.drawCh(new_pos, 'E', COLOR_YELLOW);
	new_x++;
	new_pos.setX(new_x);
	graph_man.drawCh(new_pos, ':', COLOR_YELLOW);
	new_x++;
	new_pos.setX(new_x);
	if(start_up == 0) {
		graph_man.drawCh(new_pos, s_ten.c_str()[0], COLOR_YELLOW);
		new_x++;
		new_pos.setX(new_x);
		graph_man.drawCh(new_pos, s_one.c_str()[0], COLOR_YELLOW);
	}
	else {
		graph_man.drawCh(new_pos, '-', COLOR_YELLOW);
		new_x++;
		new_pos.setX(new_x);
		graph_man.drawCh(new_pos, '-', COLOR_YELLOW);
	}
};
