//
// Title.cpp
//

#include "Title.h"
#include "Engine/ResourceManager.h"
#include "Engine/WorldManager.h"

Title::Title() {
	altitude = -2;
	count = 30;
	time = 10;
	pos.setX(42);
	pos.setY(14);
	setSolid(false);
	ResourceManager &rm = ResourceManager::getInstance();
	p_sprite = rm.getSprite("title");
	sprite_index = 0;
	sprite_slowdown = 60;
	sprite_slowdown_count = 0;
	WorldManager &wm = WorldManager::getInstance();
	wm.registerInterest(this, "EVENT_STEP");
}

Title::~Title() {
	WorldManager &wm = WorldManager::getInstance();
	wm.unregisterInterest(this, "EVENT_STEP");
};

int Title::eventHandler(Event *e) {
	if(e->getType() == "EVENT_STEP") {
		count--;
		if(count == 0) {
			time--;
			count = 30;
			if(time == 0) {
				WorldManager &wm = WorldManager::getInstance();
				wm.markForDelete(this);
			}
		}
	}
};
